## pacapt 2.3.13

=== Makefile ===
BINDIR=/usr/local/bin/
DISTRO=debian:stable

default:
	@echo "This is an experimental Makefile. Use it at your own risk."
	@echo ""
	@echo "  pacapt.dev  : Generate development script."
	@echo '  install.dev : Install development script into $$BINDIR.'
	@echo "  pacapt      : Generate stable script."
	@echo '  install     : Install stable script into $$BINDIR.'
	@echo "  clean       : (Experimental) Remove git-ignored files."
	@echo "  shellcheck  : Syntax and style checking. Use http://shellcheck.net/."
	@echo "  docker.i    : Launch interactive Docker container which mounts."
	@echo '                your local 'pacapt.dev' script to $$BINDIR/pacman.'
	@echo ""
	@echo "Environments"
	@echo ""
	@echo "  VERSION     : Version information. Default: git commit hash."
	@echo "  BINDIR      : Destination directory. Default: /usr/local/bin."
	@echo "  DISTRO      : Container image. Default: debian:stable."

# Build and install development script

pacapt.dev: ./lib/*.sh ./lib/*.txt bin/compile.sh
	@./bin/compile.sh > $(@)
	@bash -n $(@)
	@chmod 755 $(@)
	@echo 1>&2 "The output file is '$(@)' (unstable version)"

install.dev: pacapt.dev
	@if [ -e $(@) ] && ! file $(@) | grep -q 'script'; then \
		echo >&2 "Makefile Will not overwrite non-script $(@)"; \
		exit 1; \
	else \
		install -vm755 pacapt.dev $(BINDIR)/pacapt; \
	fi

# Build and install stable script

pacapt: ./lib/*.sh ./lib/*.txt bin/compile.sh
	@./bin/compile.sh > $(@)
	@bash -n $(@)
	@chmod 755 $(@)
	@echo 1>&2 "The output file is '$(@)' (stable version)"

install: $(BINDIR)/pacapt

$(BINDIR)/pacman:
	@if [ ! -e $(@) ]; then \
		ln -vs $(BINDIR)/pacapt $(@); \
	fi

$(BINDIR)/pacapt: pacapt
	@if [ -e $(@) ] && ! file $(@) | grep -q 'script'; then \
		echo >&2 "Makefile Will not overwrite non-script $(@)"; \
		exit 1; \
	else \
		install -vm755 pacapt $(BINDIR)/pacapt; \
	fi

docker.i:
	@docker run --rm -ti \
    -v $(PWD)/pacapt.dev:$(BINDIR)/pacman \
    $(DISTRO) /bin/bash

clean:
	@if git clean -nX | grep -q .; then \
		git clean -nX; \
		echo -n "Remove these files? [y/N] "; \
		read ANS; \
		case "$$ANS" in \
			[yY]*) git clean -fX ;; \
			*) exit 1;; \
		esac ; \
	fi

shellcheck:
	@./bin/check.sh _check_files bin/*.sh lib/*.sh

=== tests/Makefile ===
TESTS = *.txt

.PHONY: default
default:
	@grep -E "^# [a-z].+:" Makefile

# gen:
# gen: Generating `pacapt.dev`
tmp/pacapt.dev::
	@( cd ../ && make -s pacapt.dev ; )
	@mkdir -p ./tmp/
	@cp -u ../pacapt.dev tmp/
	@chmod 755 $(@)

# all:
# all: Execute all test scripts
# all: To execute a subset of tests, list them with TESTS=...
# all: for example, `make all TESTS="foo.txt bar.txt"
.PHONY: all
all: tmp/pacapt.dev
	@./test.sh $(TESTS)

# gen:
# gen: Generate test scripts but don't execute them
.PHONY: gen
gen: tmp/pacapt.dev
	@TESTS_DO_NOT_RUN=1 ./test.sh *.txt

# clean:
# clean: Remove all temporary files under /tmp/
# clean: (but still keep all log files.)
.PHONY: clen
clean:
	@rm -fv tmp/*.sh tmp/pacapt.dev
	@echo Please remove tmp/*.log manually.

=== debian/changelog ===
pacapt (2.3.13-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 25 Jul 2016 19:20:38 +0800

pacapt (2.3.11-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 11 Jul 2016 19:34:03 +0800

pacapt (2.3.8-2) unstable; urgency=medium

  * Use UTC time to make package reproducible.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 28 Jun 2016 22:19:07 +0800

pacapt (2.3.8-1) unstable; urgency=low

  * Initial release. Closes: #827678

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 20 Jun 2016 23:13:10 +0800

=== debian/control ===
Source: pacapt
Section: admin
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper ( >= 9.20160403),
               ruby-ronn,
Standards-Version: 3.9.8
Homepage: https://github.com/icy/pacapt
Vcs-Git: https://anonscm.debian.org/git/collab-maint/pacapt.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/pacapt.git

Package: pacapt
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Arch's pacman-like package manager for some Unices
 pacapt is an Arch's pacman-like package manager for some Unices. It is
 a bash script provides a wrapper for system's package manager.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export VERSION = $(shell dpkg-parsechangelog -S Version | sed 's/\-[^-]\+//')

DATE := $(shell date --utc --date="$$(dpkg-parsechangelog --show-field Date)" +%F)

%:
	dh $@

override_dh_auto_configure:
	cat debian/pacapt.manpages | sed 's/\.1/.1.ronn/' | xargs ronn --date=$(DATE) --roff
	dh_auto_configure

override_dh_auto_build:
	make pacapt

override_dh_auto_install:
	mkdir -p debian/pacapt/usr/bin/
	cp pacapt debian/pacapt/usr/bin/pacapt

=== debian/watch ===
# You must remove unused comment lines for the released package.
version=3
https://github.com/icy/pacapt/tags .*/v?(\d\S*)\.tar\.gz

## pacapt 2.3.14

=== Makefile ===
--- 
+++ 
@@ -12,21 +12,26 @@
 	@echo "  shellcheck  : Syntax and style checking. Use http://shellcheck.net/."
 	@echo "  docker.i    : Launch interactive Docker container which mounts."
 	@echo '                your local 'pacapt.dev' script to $$BINDIR/pacman.'
+	@echo '                Please use DISTRO= to specify Docker image'
+	@echo "  tests       : Run all tests. Please read tests/README.md first."
+	@echo "                Use TESTS= to specify a package."
 	@echo ""
 	@echo "Environments"
 	@echo ""
 	@echo "  VERSION     : Version information. Default: git commit hash."
 	@echo "  BINDIR      : Destination directory. Default: /usr/local/bin."
 	@echo "  DISTRO      : Container image. Default: debian:stable."
+	@echo "  PACAPT_STATS: Generate table of supported options."
 
 # Build and install development script
 
 pacapt.dev: ./lib/*.sh ./lib/*.txt bin/compile.sh
-	@./bin/compile.sh > $(@)
+	@./bin/compile.sh > $(@) || { rm -fv $(@); exit 1; }
 	@bash -n $(@)
 	@chmod 755 $(@)
 	@echo 1>&2 "The output file is '$(@)' (unstable version)"
 
+.PHONY: install.dev
 install.dev: pacapt.dev
 	@if [ -e $(@) ] && ! file $(@) | grep -q 'script'; then \
 		echo >&2 "Makefile Will not overwrite non-script $(@)"; \
@@ -37,12 +42,19 @@
 
 # Build and install stable script
 
-pacapt: ./lib/*.sh ./lib/*.txt bin/compile.sh
-	@./bin/compile.sh > $(@)
+.PHONY: pacapt.check
+
+pacapt.check:
+	@test -n "${VERSION}" || { echo ":: Please specify VERSION, i.e., make pacapt VERSION=1.2.3"; exit 1; }
+
+pacapt: pacapt.check ./lib/*.sh ./lib/*.txt bin/compile.sh
+	@./bin/compile.sh > $(@).tmp || { rm -fv $(@).tmp; exit 1; }
+	@mv -fv $(@).tmp $(@)
 	@bash -n $(@)
 	@chmod 755 $(@)
 	@echo 1>&2 "The output file is '$(@)' (stable version)"
 
+.PHONY: install
 install: $(BINDIR)/pacapt
 
 $(BINDIR)/pacman:
@@ -58,11 +70,13 @@
 		install -vm755 pacapt $(BINDIR)/pacapt; \
 	fi
 
+.PHONY: docker.i
 docker.i:
 	@docker run --rm -ti \
     -v $(PWD)/pacapt.dev:$(BINDIR)/pacman \
     $(DISTRO) /bin/bash
 
+.PHONY: clean
 clean:
 	@if git clean -nX | grep -q .; then \
 		git clean -nX; \
@@ -73,6 +87,12 @@
 			*) exit 1;; \
 		esac ; \
 	fi
+	@cd tests/ && make -s clean
 
+.PHONY: shellcheck
 shellcheck:
 	@./bin/check.sh _check_files bin/*.sh lib/*.sh
+
+.PHONY: tests
+tests:
+	@cd tests/ && make all

=== tests/Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 # clean:
 # clean: Remove all temporary files under /tmp/
 # clean: (but still keep all log files.)
-.PHONY: clen
+.PHONY: clean
 clean:
 	@rm -fv tmp/*.sh tmp/pacapt.dev
 	@echo Please remove tmp/*.log manually.

=== debian/changelog ===
pacapt (2.3.14-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.3.
    * Use https in Format field in debian/copyright.
  * Bump compat to 11
  * Remove unused debian/README.Debian.
  * Use asciidoc instead of ronn to write manpage.
  * Update Vcs-* fields to salsa.debian.org.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 10 Jan 2018 15:10:29 +0800

=== debian/control ===
Source: pacapt
Section: admin
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>= 11),
               asciidoc-base,
Standards-Version: 4.1.3
Homepage: https://github.com/icy/pacapt
Vcs-Git: https://salsa.debian.org/debian/pacapt.git
Vcs-Browser: https://salsa.debian.org/debian/pacapt

Package: pacapt
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Arch's pacman-like package manager for some Unices
 pacapt is an Arch's pacman-like package manager for some Unices. It is
 a bash script provides a wrapper for system's package manager.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export VERSION = ${DEB_VERSION}

%:
	dh $@

override_dh_auto_configure:
	mkdir -p ${CURDIR}/debian/bak
	cp ${CURDIR}/pacapt ${CURDIR}/debian/bak
	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --attribute=footer-style=none --doctype manpage --format manpage
	dh_auto_configure

override_dh_auto_build:
	make pacapt

override_dh_auto_install:
	mkdir -p debian/pacapt/usr/bin/
	cp pacapt debian/pacapt/usr/bin/pacapt

override_dh_clean:
	dh_clean
	-cp ${CURDIR}/debian/bak/pacapt ${CURDIR}/
